/* XND_VAR.C */

#include "xnd_def.h"

/* --------- values of parameters and their derivatives --------- */

float var_valeur (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{   int i=1;
    float par=1;
    float val;
    float *v;
    if (ordre==0) return(0);
    v = variable->value + ordre*pos;
    val = *v;
    while (i++<ordre) val += *(++v) * (par *= *temp);
    return(val);
    }

static int ex_pos;
static int ex_par;

int var_param (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{   if (ordre==0 || io > ordre) return(0);
    ex_pos = ordre*pos+io;
    ex_par = ex_pos*dim+id;
    return (variable->param[ex_par]);
    }

float var_derive (P_(void))
{   int i;
    float val=1;
    for (i=1;i<=io;i++) val *= i * *temp;
    return (val * variable->shift[ex_par]);
    }

float var_shift (P_(void))
{   return (variable->shift[ex_par]);
    }

float var_new (P_(float) deplace)
#ifdef NO_PROTO
float deplace;
#endif
{   variable->value[ex_pos] += deplace;
    return (variable->value[ex_pos]);
    }

